#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/III.h>

#include "wms_core.h"

static void WWW_class_initialize ();
static void WWW_class_part_initialize ();
static void WWW_initialize ();
static void WWW_initialize_hook ();
static void WWW_realize ();
static void WWW_destroy ();
static void WWW_resize ();
static void WWW_expose ();
static Boolean WWW_set_values ();
static Boolean WWW_set_values_hook ();
static void WWW_set_values_almost ();
static void WWW_get_values_hook ();
static Boolean WWW_accept_focus ();
static XtGeometryResult WWW_query_geometry ();
static void WWW_display_accelerator ();

void _Xwms_init_WWW (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = WWWWidgetClass;
   coreMethods->class_initialize = WWW_class_initialize;
   coreMethods->class_part_initialize = 
      WWW_class_part_initialize;
   coreMethods->initialize = WWW_initialize;
   coreMethods->initialize_hook = WWW_initialize_hook;
   coreMethods->realize = WWW_realize;
   coreMethods->destroy = WWW_destroy;
   coreMethods->resize = WWW_resize;
   coreMethods->expose = WWW_expose;
   coreMethods->set_values = WWW_set_values;
   coreMethods->set_values_hook = WWW_set_values_hook;
   coreMethods->set_values_almost = WWW_set_values_almost;
   coreMethods->get_values_hook = WWW_get_values_hook;
   coreMethods->accept_focus = WWW_accept_focus;
   coreMethods->query_geometry = WWW_query_geometry;
   coreMethods->display_accelerator = WWW_display_accelerator;
}
 
void WWW_class_initialize ()
{
   _Xwms_class_initialize (WWWWidgetClass);
}

void WWW_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, WWWWidgetClass);
} 

void WWW_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, WWWWidgetClass);
}

void WWW_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, WWWWidgetClass);
}

void WWW_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, WWWWidgetClass);
}

void WWW_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, WWWWidgetClass);
}

void WWW_resize (w)
   Widget w;
{
   _Xwms_resize (w, WWWWidgetClass);
}

void WWW_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, WWWWidgetClass);
}

Boolean WWW_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      WWWWidgetClass));
}

Boolean WWW_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      WWWWidgetClass));
}

void WWW_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      WWWWidgetClass);
}

void WWW_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, WWWWidgetClass);
}

Boolean WWW_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, WWWWidgetClass);
}

XtGeometryResult WWW_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      WWWWidgetClass));
}

void WWW_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, WWWWidgetClass);
}
