#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/ArrowB.h>

#include "wms_core.h"

static void xmArrowButton_class_initialize ();
static void xmArrowButton_class_part_initialize ();
static void xmArrowButton_initialize ();
static void xmArrowButton_initialize_hook ();
static void xmArrowButton_realize ();
static void xmArrowButton_destroy ();
static void xmArrowButton_resize ();
static void xmArrowButton_expose ();
static Boolean xmArrowButton_set_values ();
static Boolean xmArrowButton_set_values_hook ();
static void xmArrowButton_set_values_almost ();
static void xmArrowButton_get_values_hook ();
static Boolean xmArrowButton_accept_focus ();
static XtGeometryResult xmArrowButton_query_geometry ();
static void xmArrowButton_display_accelerator ();

void _Xwms_init_xmArrowButton (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmArrowButtonWidgetClass;
   coreMethods->class_initialize = xmArrowButton_class_initialize;
   coreMethods->class_part_initialize = 
      xmArrowButton_class_part_initialize;
   coreMethods->initialize = xmArrowButton_initialize;
   coreMethods->initialize_hook = xmArrowButton_initialize_hook;
   coreMethods->realize = xmArrowButton_realize;
   coreMethods->destroy = xmArrowButton_destroy;
   coreMethods->resize = xmArrowButton_resize;
   coreMethods->expose = xmArrowButton_expose;
   coreMethods->set_values = xmArrowButton_set_values;
   coreMethods->set_values_hook = xmArrowButton_set_values_hook;
   coreMethods->set_values_almost = xmArrowButton_set_values_almost;
   coreMethods->get_values_hook = xmArrowButton_get_values_hook;
   coreMethods->accept_focus = xmArrowButton_accept_focus;
   coreMethods->query_geometry = xmArrowButton_query_geometry;
   coreMethods->display_accelerator = xmArrowButton_display_accelerator;
}
 
void xmArrowButton_class_initialize ()
{
   _Xwms_class_initialize (xmArrowButtonWidgetClass);
}

void xmArrowButton_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmArrowButtonWidgetClass);
} 

void xmArrowButton_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmArrowButtonWidgetClass);
}

void xmArrowButton_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmArrowButtonWidgetClass);
}

void xmArrowButton_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmArrowButtonWidgetClass);
}

void xmArrowButton_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmArrowButtonWidgetClass);
}

void xmArrowButton_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmArrowButtonWidgetClass);
}

void xmArrowButton_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmArrowButtonWidgetClass);
}

Boolean xmArrowButton_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmArrowButtonWidgetClass));
}

Boolean xmArrowButton_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmArrowButtonWidgetClass));
}

void xmArrowButton_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmArrowButtonWidgetClass);
}

void xmArrowButton_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmArrowButtonWidgetClass);
}

Boolean xmArrowButton_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmArrowButtonWidgetClass);
}

XtGeometryResult xmArrowButton_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmArrowButtonWidgetClass));
}

void xmArrowButton_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmArrowButtonWidgetClass);
}
