#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/BulletinB.h>

#include "wms_core.h"

static void xmBulletinBoard_class_initialize ();
static void xmBulletinBoard_class_part_initialize ();
static void xmBulletinBoard_initialize ();
static void xmBulletinBoard_initialize_hook ();
static void xmBulletinBoard_realize ();
static void xmBulletinBoard_destroy ();
static void xmBulletinBoard_resize ();
static void xmBulletinBoard_expose ();
static Boolean xmBulletinBoard_set_values ();
static Boolean xmBulletinBoard_set_values_hook ();
static void xmBulletinBoard_set_values_almost ();
static void xmBulletinBoard_get_values_hook ();
static Boolean xmBulletinBoard_accept_focus ();
static XtGeometryResult xmBulletinBoard_query_geometry ();
static void xmBulletinBoard_display_accelerator ();

void _Xwms_init_xmBulletinBoard (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmBulletinBoardWidgetClass;
   coreMethods->class_initialize = xmBulletinBoard_class_initialize;
   coreMethods->class_part_initialize = 
      xmBulletinBoard_class_part_initialize;
   coreMethods->initialize = xmBulletinBoard_initialize;
   coreMethods->initialize_hook = xmBulletinBoard_initialize_hook;
   coreMethods->realize = xmBulletinBoard_realize;
   coreMethods->destroy = xmBulletinBoard_destroy;
   coreMethods->resize = xmBulletinBoard_resize;
   coreMethods->expose = xmBulletinBoard_expose;
   coreMethods->set_values = xmBulletinBoard_set_values;
   coreMethods->set_values_hook = xmBulletinBoard_set_values_hook;
   coreMethods->set_values_almost = xmBulletinBoard_set_values_almost;
   coreMethods->get_values_hook = xmBulletinBoard_get_values_hook;
   coreMethods->accept_focus = xmBulletinBoard_accept_focus;
   coreMethods->query_geometry = xmBulletinBoard_query_geometry;
   coreMethods->display_accelerator = xmBulletinBoard_display_accelerator;
}
 
void xmBulletinBoard_class_initialize ()
{
   _Xwms_class_initialize (xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmBulletinBoardWidgetClass);
} 

void xmBulletinBoard_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmBulletinBoardWidgetClass);
}

Boolean xmBulletinBoard_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmBulletinBoardWidgetClass));
}

Boolean xmBulletinBoard_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmBulletinBoardWidgetClass));
}

void xmBulletinBoard_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmBulletinBoardWidgetClass);
}

void xmBulletinBoard_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmBulletinBoardWidgetClass);
}

Boolean xmBulletinBoard_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmBulletinBoardWidgetClass);
}

XtGeometryResult xmBulletinBoard_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmBulletinBoardWidgetClass));
}

void xmBulletinBoard_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmBulletinBoardWidgetClass);
}
