#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/CascadeB.h>

#include "wms_core.h"

static void xmCascadeButton_class_initialize ();
static void xmCascadeButton_class_part_initialize ();
static void xmCascadeButton_initialize ();
static void xmCascadeButton_initialize_hook ();
static void xmCascadeButton_realize ();
static void xmCascadeButton_destroy ();
static void xmCascadeButton_resize ();
static void xmCascadeButton_expose ();
static Boolean xmCascadeButton_set_values ();
static Boolean xmCascadeButton_set_values_hook ();
static void xmCascadeButton_set_values_almost ();
static void xmCascadeButton_get_values_hook ();
static Boolean xmCascadeButton_accept_focus ();
static XtGeometryResult xmCascadeButton_query_geometry ();
static void xmCascadeButton_display_accelerator ();

void _Xwms_init_xmCascadeButton (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmCascadeButtonWidgetClass;
   coreMethods->class_initialize = xmCascadeButton_class_initialize;
   coreMethods->class_part_initialize = 
      xmCascadeButton_class_part_initialize;
   coreMethods->initialize = xmCascadeButton_initialize;
   coreMethods->initialize_hook = xmCascadeButton_initialize_hook;
   coreMethods->realize = xmCascadeButton_realize;
   coreMethods->destroy = xmCascadeButton_destroy;
   coreMethods->resize = xmCascadeButton_resize;
   coreMethods->expose = xmCascadeButton_expose;
   coreMethods->set_values = xmCascadeButton_set_values;
   coreMethods->set_values_hook = xmCascadeButton_set_values_hook;
   coreMethods->set_values_almost = xmCascadeButton_set_values_almost;
   coreMethods->get_values_hook = xmCascadeButton_get_values_hook;
   coreMethods->accept_focus = xmCascadeButton_accept_focus;
   coreMethods->query_geometry = xmCascadeButton_query_geometry;
   coreMethods->display_accelerator = xmCascadeButton_display_accelerator;
}
 
void xmCascadeButton_class_initialize ()
{
   _Xwms_class_initialize (xmCascadeButtonWidgetClass);
}

void xmCascadeButton_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmCascadeButtonWidgetClass);
} 

void xmCascadeButton_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmCascadeButtonWidgetClass);
}

void xmCascadeButton_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmCascadeButtonWidgetClass);
}

void xmCascadeButton_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmCascadeButtonWidgetClass);
}

void xmCascadeButton_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmCascadeButtonWidgetClass);
}

void xmCascadeButton_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmCascadeButtonWidgetClass);
}

void xmCascadeButton_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmCascadeButtonWidgetClass);
}

Boolean xmCascadeButton_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmCascadeButtonWidgetClass));
}

Boolean xmCascadeButton_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmCascadeButtonWidgetClass));
}

void xmCascadeButton_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmCascadeButtonWidgetClass);
}

void xmCascadeButton_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmCascadeButtonWidgetClass);
}

Boolean xmCascadeButton_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmCascadeButtonWidgetClass);
}

XtGeometryResult xmCascadeButton_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmCascadeButtonWidgetClass));
}

void xmCascadeButton_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmCascadeButtonWidgetClass);
}
