#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Command.h>

#include "wms_core.h"

static void xmCommand_class_initialize ();
static void xmCommand_class_part_initialize ();
static void xmCommand_initialize ();
static void xmCommand_initialize_hook ();
static void xmCommand_realize ();
static void xmCommand_destroy ();
static void xmCommand_resize ();
static void xmCommand_expose ();
static Boolean xmCommand_set_values ();
static Boolean xmCommand_set_values_hook ();
static void xmCommand_set_values_almost ();
static void xmCommand_get_values_hook ();
static Boolean xmCommand_accept_focus ();
static XtGeometryResult xmCommand_query_geometry ();
static void xmCommand_display_accelerator ();

void _Xwms_init_xmCommand (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmCommandWidgetClass;
   coreMethods->class_initialize = xmCommand_class_initialize;
   coreMethods->class_part_initialize = 
      xmCommand_class_part_initialize;
   coreMethods->initialize = xmCommand_initialize;
   coreMethods->initialize_hook = xmCommand_initialize_hook;
   coreMethods->realize = xmCommand_realize;
   coreMethods->destroy = xmCommand_destroy;
   coreMethods->resize = xmCommand_resize;
   coreMethods->expose = xmCommand_expose;
   coreMethods->set_values = xmCommand_set_values;
   coreMethods->set_values_hook = xmCommand_set_values_hook;
   coreMethods->set_values_almost = xmCommand_set_values_almost;
   coreMethods->get_values_hook = xmCommand_get_values_hook;
   coreMethods->accept_focus = xmCommand_accept_focus;
   coreMethods->query_geometry = xmCommand_query_geometry;
   coreMethods->display_accelerator = xmCommand_display_accelerator;
}
 
void xmCommand_class_initialize ()
{
   _Xwms_class_initialize (xmCommandWidgetClass);
}

void xmCommand_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmCommandWidgetClass);
} 

void xmCommand_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmCommandWidgetClass);
}

void xmCommand_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmCommandWidgetClass);
}

void xmCommand_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmCommandWidgetClass);
}

void xmCommand_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmCommandWidgetClass);
}

void xmCommand_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmCommandWidgetClass);
}

void xmCommand_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmCommandWidgetClass);
}

Boolean xmCommand_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmCommandWidgetClass));
}

Boolean xmCommand_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmCommandWidgetClass));
}

void xmCommand_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmCommandWidgetClass);
}

void xmCommand_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmCommandWidgetClass);
}

Boolean xmCommand_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmCommandWidgetClass);
}

XtGeometryResult xmCommand_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmCommandWidgetClass));
}

void xmCommand_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmCommandWidgetClass);
}
