#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/FileSB.h>

#include "wms_core.h"

static void xmFileSelectionBox_class_initialize ();
static void xmFileSelectionBox_class_part_initialize ();
static void xmFileSelectionBox_initialize ();
static void xmFileSelectionBox_initialize_hook ();
static void xmFileSelectionBox_realize ();
static void xmFileSelectionBox_destroy ();
static void xmFileSelectionBox_resize ();
static void xmFileSelectionBox_expose ();
static Boolean xmFileSelectionBox_set_values ();
static Boolean xmFileSelectionBox_set_values_hook ();
static void xmFileSelectionBox_set_values_almost ();
static void xmFileSelectionBox_get_values_hook ();
static Boolean xmFileSelectionBox_accept_focus ();
static XtGeometryResult xmFileSelectionBox_query_geometry ();
static void xmFileSelectionBox_display_accelerator ();

void _Xwms_init_xmFileSelectionBox (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmFileSelectionBoxWidgetClass;
   coreMethods->class_initialize = xmFileSelectionBox_class_initialize;
   coreMethods->class_part_initialize = 
      xmFileSelectionBox_class_part_initialize;
   coreMethods->initialize = xmFileSelectionBox_initialize;
   coreMethods->initialize_hook = xmFileSelectionBox_initialize_hook;
   coreMethods->realize = xmFileSelectionBox_realize;
   coreMethods->destroy = xmFileSelectionBox_destroy;
   coreMethods->resize = xmFileSelectionBox_resize;
   coreMethods->expose = xmFileSelectionBox_expose;
   coreMethods->set_values = xmFileSelectionBox_set_values;
   coreMethods->set_values_hook = xmFileSelectionBox_set_values_hook;
   coreMethods->set_values_almost = xmFileSelectionBox_set_values_almost;
   coreMethods->get_values_hook = xmFileSelectionBox_get_values_hook;
   coreMethods->accept_focus = xmFileSelectionBox_accept_focus;
   coreMethods->query_geometry = xmFileSelectionBox_query_geometry;
   coreMethods->display_accelerator = xmFileSelectionBox_display_accelerator;
}
 
void xmFileSelectionBox_class_initialize ()
{
   _Xwms_class_initialize (xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmFileSelectionBoxWidgetClass);
} 

void xmFileSelectionBox_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmFileSelectionBoxWidgetClass);
}

Boolean xmFileSelectionBox_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmFileSelectionBoxWidgetClass));
}

Boolean xmFileSelectionBox_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmFileSelectionBoxWidgetClass));
}

void xmFileSelectionBox_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmFileSelectionBoxWidgetClass);
}

void xmFileSelectionBox_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmFileSelectionBoxWidgetClass);
}

Boolean xmFileSelectionBox_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmFileSelectionBoxWidgetClass);
}

XtGeometryResult xmFileSelectionBox_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmFileSelectionBoxWidgetClass));
}

void xmFileSelectionBox_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmFileSelectionBoxWidgetClass);
}
