#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Form.h>

#include "wms_core.h"

static void xmForm_class_initialize ();
static void xmForm_class_part_initialize ();
static void xmForm_initialize ();
static void xmForm_initialize_hook ();
static void xmForm_realize ();
static void xmForm_destroy ();
static void xmForm_resize ();
static void xmForm_expose ();
static Boolean xmForm_set_values ();
static Boolean xmForm_set_values_hook ();
static void xmForm_set_values_almost ();
static void xmForm_get_values_hook ();
static Boolean xmForm_accept_focus ();
static XtGeometryResult xmForm_query_geometry ();
static void xmForm_display_accelerator ();

void _Xwms_init_xmForm (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmFormWidgetClass;
   coreMethods->class_initialize = xmForm_class_initialize;
   coreMethods->class_part_initialize = 
      xmForm_class_part_initialize;
   coreMethods->initialize = xmForm_initialize;
   coreMethods->initialize_hook = xmForm_initialize_hook;
   coreMethods->realize = xmForm_realize;
   coreMethods->destroy = xmForm_destroy;
   coreMethods->resize = xmForm_resize;
   coreMethods->expose = xmForm_expose;
   coreMethods->set_values = xmForm_set_values;
   coreMethods->set_values_hook = xmForm_set_values_hook;
   coreMethods->set_values_almost = xmForm_set_values_almost;
   coreMethods->get_values_hook = xmForm_get_values_hook;
   coreMethods->accept_focus = xmForm_accept_focus;
   coreMethods->query_geometry = xmForm_query_geometry;
   coreMethods->display_accelerator = xmForm_display_accelerator;
}
 
void xmForm_class_initialize ()
{
   _Xwms_class_initialize (xmFormWidgetClass);
}

void xmForm_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmFormWidgetClass);
} 

void xmForm_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmFormWidgetClass);
}

void xmForm_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmFormWidgetClass);
}

void xmForm_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmFormWidgetClass);
}

void xmForm_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmFormWidgetClass);
}

void xmForm_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmFormWidgetClass);
}

void xmForm_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmFormWidgetClass);
}

Boolean xmForm_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmFormWidgetClass));
}

Boolean xmForm_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmFormWidgetClass));
}

void xmForm_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmFormWidgetClass);
}

void xmForm_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmFormWidgetClass);
}

Boolean xmForm_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmFormWidgetClass);
}

XtGeometryResult xmForm_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmFormWidgetClass));
}

void xmForm_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmFormWidgetClass);
}
