#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Frame.h>

#include "wms_core.h"

static void xmFrame_class_initialize ();
static void xmFrame_class_part_initialize ();
static void xmFrame_initialize ();
static void xmFrame_initialize_hook ();
static void xmFrame_realize ();
static void xmFrame_destroy ();
static void xmFrame_resize ();
static void xmFrame_expose ();
static Boolean xmFrame_set_values ();
static Boolean xmFrame_set_values_hook ();
static void xmFrame_set_values_almost ();
static void xmFrame_get_values_hook ();
static Boolean xmFrame_accept_focus ();
static XtGeometryResult xmFrame_query_geometry ();
static void xmFrame_display_accelerator ();

void _Xwms_init_xmFrame (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmFrameWidgetClass;
   coreMethods->class_initialize = xmFrame_class_initialize;
   coreMethods->class_part_initialize = 
      xmFrame_class_part_initialize;
   coreMethods->initialize = xmFrame_initialize;
   coreMethods->initialize_hook = xmFrame_initialize_hook;
   coreMethods->realize = xmFrame_realize;
   coreMethods->destroy = xmFrame_destroy;
   coreMethods->resize = xmFrame_resize;
   coreMethods->expose = xmFrame_expose;
   coreMethods->set_values = xmFrame_set_values;
   coreMethods->set_values_hook = xmFrame_set_values_hook;
   coreMethods->set_values_almost = xmFrame_set_values_almost;
   coreMethods->get_values_hook = xmFrame_get_values_hook;
   coreMethods->accept_focus = xmFrame_accept_focus;
   coreMethods->query_geometry = xmFrame_query_geometry;
   coreMethods->display_accelerator = xmFrame_display_accelerator;
}
 
void xmFrame_class_initialize ()
{
   _Xwms_class_initialize (xmFrameWidgetClass);
}

void xmFrame_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmFrameWidgetClass);
} 

void xmFrame_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmFrameWidgetClass);
}

void xmFrame_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmFrameWidgetClass);
}

void xmFrame_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmFrameWidgetClass);
}

void xmFrame_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmFrameWidgetClass);
}

void xmFrame_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmFrameWidgetClass);
}

void xmFrame_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmFrameWidgetClass);
}

Boolean xmFrame_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmFrameWidgetClass));
}

Boolean xmFrame_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmFrameWidgetClass));
}

void xmFrame_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmFrameWidgetClass);
}

void xmFrame_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmFrameWidgetClass);
}

Boolean xmFrame_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmFrameWidgetClass);
}

XtGeometryResult xmFrame_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmFrameWidgetClass));
}

void xmFrame_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmFrameWidgetClass);
}
