#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Label.h>

#include "wms_core.h"

static void xmLabel_class_initialize ();
static void xmLabel_class_part_initialize ();
static void xmLabel_initialize ();
static void xmLabel_initialize_hook ();
static void xmLabel_realize ();
static void xmLabel_destroy ();
static void xmLabel_resize ();
static void xmLabel_expose ();
static Boolean xmLabel_set_values ();
static Boolean xmLabel_set_values_hook ();
static void xmLabel_set_values_almost ();
static void xmLabel_get_values_hook ();
static Boolean xmLabel_accept_focus ();
static XtGeometryResult xmLabel_query_geometry ();
static void xmLabel_display_accelerator ();

void _Xwms_init_xmLabel (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmLabelWidgetClass;
   coreMethods->class_initialize = xmLabel_class_initialize;
   coreMethods->class_part_initialize = 
      xmLabel_class_part_initialize;
   coreMethods->initialize = xmLabel_initialize;
   coreMethods->initialize_hook = xmLabel_initialize_hook;
   coreMethods->realize = xmLabel_realize;
   coreMethods->destroy = xmLabel_destroy;
   coreMethods->resize = xmLabel_resize;
   coreMethods->expose = xmLabel_expose;
   coreMethods->set_values = xmLabel_set_values;
   coreMethods->set_values_hook = xmLabel_set_values_hook;
   coreMethods->set_values_almost = xmLabel_set_values_almost;
   coreMethods->get_values_hook = xmLabel_get_values_hook;
   coreMethods->accept_focus = xmLabel_accept_focus;
   coreMethods->query_geometry = xmLabel_query_geometry;
   coreMethods->display_accelerator = xmLabel_display_accelerator;
}
 
void xmLabel_class_initialize ()
{
   _Xwms_class_initialize (xmLabelWidgetClass);
}

void xmLabel_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmLabelWidgetClass);
} 

void xmLabel_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmLabelWidgetClass);
}

void xmLabel_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmLabelWidgetClass);
}

void xmLabel_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmLabelWidgetClass);
}

void xmLabel_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmLabelWidgetClass);
}

void xmLabel_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmLabelWidgetClass);
}

void xmLabel_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmLabelWidgetClass);
}

Boolean xmLabel_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmLabelWidgetClass));
}

Boolean xmLabel_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmLabelWidgetClass));
}

void xmLabel_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmLabelWidgetClass);
}

void xmLabel_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmLabelWidgetClass);
}

Boolean xmLabel_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmLabelWidgetClass);
}

XtGeometryResult xmLabel_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmLabelWidgetClass));
}

void xmLabel_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmLabelWidgetClass);
}
