#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/List.h>

#include "wms_core.h"

static void xmList_class_initialize ();
static void xmList_class_part_initialize ();
static void xmList_initialize ();
static void xmList_initialize_hook ();
static void xmList_realize ();
static void xmList_destroy ();
static void xmList_resize ();
static void xmList_expose ();
static Boolean xmList_set_values ();
static Boolean xmList_set_values_hook ();
static void xmList_set_values_almost ();
static void xmList_get_values_hook ();
static Boolean xmList_accept_focus ();
static XtGeometryResult xmList_query_geometry ();
static void xmList_display_accelerator ();

void _Xwms_init_xmList (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmListWidgetClass;
   coreMethods->class_initialize = xmList_class_initialize;
   coreMethods->class_part_initialize = 
      xmList_class_part_initialize;
   coreMethods->initialize = xmList_initialize;
   coreMethods->initialize_hook = xmList_initialize_hook;
   coreMethods->realize = xmList_realize;
   coreMethods->destroy = xmList_destroy;
   coreMethods->resize = xmList_resize;
   coreMethods->expose = xmList_expose;
   coreMethods->set_values = xmList_set_values;
   coreMethods->set_values_hook = xmList_set_values_hook;
   coreMethods->set_values_almost = xmList_set_values_almost;
   coreMethods->get_values_hook = xmList_get_values_hook;
   coreMethods->accept_focus = xmList_accept_focus;
   coreMethods->query_geometry = xmList_query_geometry;
   coreMethods->display_accelerator = xmList_display_accelerator;
}
 
void xmList_class_initialize ()
{
   _Xwms_class_initialize (xmListWidgetClass);
}

void xmList_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmListWidgetClass);
} 

void xmList_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmListWidgetClass);
}

void xmList_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmListWidgetClass);
}

void xmList_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmListWidgetClass);
}

void xmList_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmListWidgetClass);
}

void xmList_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmListWidgetClass);
}

void xmList_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmListWidgetClass);
}

Boolean xmList_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmListWidgetClass));
}

Boolean xmList_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmListWidgetClass));
}

void xmList_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmListWidgetClass);
}

void xmList_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmListWidgetClass);
}

Boolean xmList_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmListWidgetClass);
}

XtGeometryResult xmList_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmListWidgetClass));
}

void xmList_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmListWidgetClass);
}
