#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/MainW.h>

#include "wms_core.h"

static void xmMainWindow_class_initialize ();
static void xmMainWindow_class_part_initialize ();
static void xmMainWindow_initialize ();
static void xmMainWindow_initialize_hook ();
static void xmMainWindow_realize ();
static void xmMainWindow_destroy ();
static void xmMainWindow_resize ();
static void xmMainWindow_expose ();
static Boolean xmMainWindow_set_values ();
static Boolean xmMainWindow_set_values_hook ();
static void xmMainWindow_set_values_almost ();
static void xmMainWindow_get_values_hook ();
static Boolean xmMainWindow_accept_focus ();
static XtGeometryResult xmMainWindow_query_geometry ();
static void xmMainWindow_display_accelerator ();

void _Xwms_init_xmMainWindow (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmMainWindowWidgetClass;
   coreMethods->class_initialize = xmMainWindow_class_initialize;
   coreMethods->class_part_initialize = 
      xmMainWindow_class_part_initialize;
   coreMethods->initialize = xmMainWindow_initialize;
   coreMethods->initialize_hook = xmMainWindow_initialize_hook;
   coreMethods->realize = xmMainWindow_realize;
   coreMethods->destroy = xmMainWindow_destroy;
   coreMethods->resize = xmMainWindow_resize;
   coreMethods->expose = xmMainWindow_expose;
   coreMethods->set_values = xmMainWindow_set_values;
   coreMethods->set_values_hook = xmMainWindow_set_values_hook;
   coreMethods->set_values_almost = xmMainWindow_set_values_almost;
   coreMethods->get_values_hook = xmMainWindow_get_values_hook;
   coreMethods->accept_focus = xmMainWindow_accept_focus;
   coreMethods->query_geometry = xmMainWindow_query_geometry;
   coreMethods->display_accelerator = xmMainWindow_display_accelerator;
}
 
void xmMainWindow_class_initialize ()
{
   _Xwms_class_initialize (xmMainWindowWidgetClass);
}

void xmMainWindow_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmMainWindowWidgetClass);
} 

void xmMainWindow_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmMainWindowWidgetClass);
}

void xmMainWindow_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmMainWindowWidgetClass);
}

void xmMainWindow_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmMainWindowWidgetClass);
}

void xmMainWindow_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmMainWindowWidgetClass);
}

void xmMainWindow_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmMainWindowWidgetClass);
}

void xmMainWindow_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmMainWindowWidgetClass);
}

Boolean xmMainWindow_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmMainWindowWidgetClass));
}

Boolean xmMainWindow_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmMainWindowWidgetClass));
}

void xmMainWindow_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmMainWindowWidgetClass);
}

void xmMainWindow_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmMainWindowWidgetClass);
}

Boolean xmMainWindow_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmMainWindowWidgetClass);
}

XtGeometryResult xmMainWindow_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmMainWindowWidgetClass));
}

void xmMainWindow_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmMainWindowWidgetClass);
}
