#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/MenuShell.h>

#include "wms_core.h"

static void xmMenuShell_class_initialize ();
static void xmMenuShell_class_part_initialize ();
static void xmMenuShell_initialize ();
static void xmMenuShell_initialize_hook ();
static void xmMenuShell_realize ();
static void xmMenuShell_destroy ();
static void xmMenuShell_resize ();
static void xmMenuShell_expose ();
static Boolean xmMenuShell_set_values ();
static Boolean xmMenuShell_set_values_hook ();
static void xmMenuShell_set_values_almost ();
static void xmMenuShell_get_values_hook ();
static Boolean xmMenuShell_accept_focus ();
static XtGeometryResult xmMenuShell_query_geometry ();
static void xmMenuShell_display_accelerator ();

void _Xwms_init_xmMenuShell (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmMenuShellWidgetClass;
   coreMethods->class_initialize = xmMenuShell_class_initialize;
   coreMethods->class_part_initialize = 
      xmMenuShell_class_part_initialize;
   coreMethods->initialize = xmMenuShell_initialize;
   coreMethods->initialize_hook = xmMenuShell_initialize_hook;
   coreMethods->realize = xmMenuShell_realize;
   coreMethods->destroy = xmMenuShell_destroy;
   coreMethods->resize = xmMenuShell_resize;
   coreMethods->expose = xmMenuShell_expose;
   coreMethods->set_values = xmMenuShell_set_values;
   coreMethods->set_values_hook = xmMenuShell_set_values_hook;
   coreMethods->set_values_almost = xmMenuShell_set_values_almost;
   coreMethods->get_values_hook = xmMenuShell_get_values_hook;
   coreMethods->accept_focus = xmMenuShell_accept_focus;
   coreMethods->query_geometry = xmMenuShell_query_geometry;
   coreMethods->display_accelerator = xmMenuShell_display_accelerator;
}
 
void xmMenuShell_class_initialize ()
{
   _Xwms_class_initialize (xmMenuShellWidgetClass);
}

void xmMenuShell_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmMenuShellWidgetClass);
} 

void xmMenuShell_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmMenuShellWidgetClass);
}

void xmMenuShell_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmMenuShellWidgetClass);
}

void xmMenuShell_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmMenuShellWidgetClass);
}

void xmMenuShell_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmMenuShellWidgetClass);
}

void xmMenuShell_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmMenuShellWidgetClass);
}

void xmMenuShell_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmMenuShellWidgetClass);
}

Boolean xmMenuShell_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmMenuShellWidgetClass));
}

Boolean xmMenuShell_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmMenuShellWidgetClass));
}

void xmMenuShell_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmMenuShellWidgetClass);
}

void xmMenuShell_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmMenuShellWidgetClass);
}

Boolean xmMenuShell_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmMenuShellWidgetClass);
}

XtGeometryResult xmMenuShell_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmMenuShellWidgetClass));
}

void xmMenuShell_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmMenuShellWidgetClass);
}
