#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/PanedW.h>

#include "wms_core.h"

static void xmPanedWindow_class_initialize ();
static void xmPanedWindow_class_part_initialize ();
static void xmPanedWindow_initialize ();
static void xmPanedWindow_initialize_hook ();
static void xmPanedWindow_realize ();
static void xmPanedWindow_destroy ();
static void xmPanedWindow_resize ();
static void xmPanedWindow_expose ();
static Boolean xmPanedWindow_set_values ();
static Boolean xmPanedWindow_set_values_hook ();
static void xmPanedWindow_set_values_almost ();
static void xmPanedWindow_get_values_hook ();
static Boolean xmPanedWindow_accept_focus ();
static XtGeometryResult xmPanedWindow_query_geometry ();
static void xmPanedWindow_display_accelerator ();

void _Xwms_init_xmPanedWindow (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmPanedWindowWidgetClass;
   coreMethods->class_initialize = xmPanedWindow_class_initialize;
   coreMethods->class_part_initialize = 
      xmPanedWindow_class_part_initialize;
   coreMethods->initialize = xmPanedWindow_initialize;
   coreMethods->initialize_hook = xmPanedWindow_initialize_hook;
   coreMethods->realize = xmPanedWindow_realize;
   coreMethods->destroy = xmPanedWindow_destroy;
   coreMethods->resize = xmPanedWindow_resize;
   coreMethods->expose = xmPanedWindow_expose;
   coreMethods->set_values = xmPanedWindow_set_values;
   coreMethods->set_values_hook = xmPanedWindow_set_values_hook;
   coreMethods->set_values_almost = xmPanedWindow_set_values_almost;
   coreMethods->get_values_hook = xmPanedWindow_get_values_hook;
   coreMethods->accept_focus = xmPanedWindow_accept_focus;
   coreMethods->query_geometry = xmPanedWindow_query_geometry;
   coreMethods->display_accelerator = xmPanedWindow_display_accelerator;
}
 
void xmPanedWindow_class_initialize ()
{
   _Xwms_class_initialize (xmPanedWindowWidgetClass);
}

void xmPanedWindow_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmPanedWindowWidgetClass);
} 

void xmPanedWindow_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmPanedWindowWidgetClass);
}

void xmPanedWindow_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmPanedWindowWidgetClass);
}

void xmPanedWindow_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmPanedWindowWidgetClass);
}

void xmPanedWindow_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmPanedWindowWidgetClass);
}

void xmPanedWindow_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmPanedWindowWidgetClass);
}

void xmPanedWindow_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmPanedWindowWidgetClass);
}

Boolean xmPanedWindow_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmPanedWindowWidgetClass));
}

Boolean xmPanedWindow_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmPanedWindowWidgetClass));
}

void xmPanedWindow_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmPanedWindowWidgetClass);
}

void xmPanedWindow_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmPanedWindowWidgetClass);
}

Boolean xmPanedWindow_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmPanedWindowWidgetClass);
}

XtGeometryResult xmPanedWindow_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmPanedWindowWidgetClass));
}

void xmPanedWindow_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmPanedWindowWidgetClass);
}
