#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/PushB.h>

#include "wms_core.h"

static void xmPushButton_class_initialize ();
static void xmPushButton_class_part_initialize ();
static void xmPushButton_initialize ();
static void xmPushButton_initialize_hook ();
static void xmPushButton_realize ();
static void xmPushButton_destroy ();
static void xmPushButton_resize ();
static void xmPushButton_expose ();
static Boolean xmPushButton_set_values ();
static Boolean xmPushButton_set_values_hook ();
static void xmPushButton_set_values_almost ();
static void xmPushButton_get_values_hook ();
static Boolean xmPushButton_accept_focus ();
static XtGeometryResult xmPushButton_query_geometry ();
static void xmPushButton_display_accelerator ();

void _Xwms_init_xmPushButton (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmPushButtonWidgetClass;
   coreMethods->class_initialize = xmPushButton_class_initialize;
   coreMethods->class_part_initialize = 
      xmPushButton_class_part_initialize;
   coreMethods->initialize = xmPushButton_initialize;
   coreMethods->initialize_hook = xmPushButton_initialize_hook;
   coreMethods->realize = xmPushButton_realize;
   coreMethods->destroy = xmPushButton_destroy;
   coreMethods->resize = xmPushButton_resize;
   coreMethods->expose = xmPushButton_expose;
   coreMethods->set_values = xmPushButton_set_values;
   coreMethods->set_values_hook = xmPushButton_set_values_hook;
   coreMethods->set_values_almost = xmPushButton_set_values_almost;
   coreMethods->get_values_hook = xmPushButton_get_values_hook;
   coreMethods->accept_focus = xmPushButton_accept_focus;
   coreMethods->query_geometry = xmPushButton_query_geometry;
   coreMethods->display_accelerator = xmPushButton_display_accelerator;
}
 
void xmPushButton_class_initialize ()
{
   _Xwms_class_initialize (xmPushButtonWidgetClass);
}

void xmPushButton_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmPushButtonWidgetClass);
} 

void xmPushButton_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmPushButtonWidgetClass);
}

void xmPushButton_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmPushButtonWidgetClass);
}

void xmPushButton_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmPushButtonWidgetClass);
}

void xmPushButton_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmPushButtonWidgetClass);
}

void xmPushButton_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmPushButtonWidgetClass);
}

void xmPushButton_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmPushButtonWidgetClass);
}

Boolean xmPushButton_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmPushButtonWidgetClass));
}

Boolean xmPushButton_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmPushButtonWidgetClass));
}

void xmPushButton_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmPushButtonWidgetClass);
}

void xmPushButton_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmPushButtonWidgetClass);
}

Boolean xmPushButton_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmPushButtonWidgetClass);
}

XtGeometryResult xmPushButton_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmPushButtonWidgetClass));
}

void xmPushButton_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmPushButtonWidgetClass);
}
