#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Scale.h>

#include "wms_core.h"

static void xmScale_class_initialize ();
static void xmScale_class_part_initialize ();
static void xmScale_initialize ();
static void xmScale_initialize_hook ();
static void xmScale_realize ();
static void xmScale_destroy ();
static void xmScale_resize ();
static void xmScale_expose ();
static Boolean xmScale_set_values ();
static Boolean xmScale_set_values_hook ();
static void xmScale_set_values_almost ();
static void xmScale_get_values_hook ();
static Boolean xmScale_accept_focus ();
static XtGeometryResult xmScale_query_geometry ();
static void xmScale_display_accelerator ();

void _Xwms_init_xmScale (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmScaleWidgetClass;
   coreMethods->class_initialize = xmScale_class_initialize;
   coreMethods->class_part_initialize = 
      xmScale_class_part_initialize;
   coreMethods->initialize = xmScale_initialize;
   coreMethods->initialize_hook = xmScale_initialize_hook;
   coreMethods->realize = xmScale_realize;
   coreMethods->destroy = xmScale_destroy;
   coreMethods->resize = xmScale_resize;
   coreMethods->expose = xmScale_expose;
   coreMethods->set_values = xmScale_set_values;
   coreMethods->set_values_hook = xmScale_set_values_hook;
   coreMethods->set_values_almost = xmScale_set_values_almost;
   coreMethods->get_values_hook = xmScale_get_values_hook;
   coreMethods->accept_focus = xmScale_accept_focus;
   coreMethods->query_geometry = xmScale_query_geometry;
   coreMethods->display_accelerator = xmScale_display_accelerator;
}
 
void xmScale_class_initialize ()
{
   _Xwms_class_initialize (xmScaleWidgetClass);
}

void xmScale_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmScaleWidgetClass);
} 

void xmScale_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmScaleWidgetClass);
}

void xmScale_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmScaleWidgetClass);
}

void xmScale_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmScaleWidgetClass);
}

void xmScale_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmScaleWidgetClass);
}

void xmScale_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmScaleWidgetClass);
}

void xmScale_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmScaleWidgetClass);
}

Boolean xmScale_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmScaleWidgetClass));
}

Boolean xmScale_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmScaleWidgetClass));
}

void xmScale_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmScaleWidgetClass);
}

void xmScale_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmScaleWidgetClass);
}

Boolean xmScale_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmScaleWidgetClass);
}

XtGeometryResult xmScale_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmScaleWidgetClass));
}

void xmScale_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmScaleWidgetClass);
}
