#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/ScrollBar.h>

#include "wms_core.h"

static void xmScrollBar_class_initialize ();
static void xmScrollBar_class_part_initialize ();
static void xmScrollBar_initialize ();
static void xmScrollBar_initialize_hook ();
static void xmScrollBar_realize ();
static void xmScrollBar_destroy ();
static void xmScrollBar_resize ();
static void xmScrollBar_expose ();
static Boolean xmScrollBar_set_values ();
static Boolean xmScrollBar_set_values_hook ();
static void xmScrollBar_set_values_almost ();
static void xmScrollBar_get_values_hook ();
static Boolean xmScrollBar_accept_focus ();
static XtGeometryResult xmScrollBar_query_geometry ();
static void xmScrollBar_display_accelerator ();

void _Xwms_init_xmScrollBar (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmScrollBarWidgetClass;
   coreMethods->class_initialize = xmScrollBar_class_initialize;
   coreMethods->class_part_initialize = 
      xmScrollBar_class_part_initialize;
   coreMethods->initialize = xmScrollBar_initialize;
   coreMethods->initialize_hook = xmScrollBar_initialize_hook;
   coreMethods->realize = xmScrollBar_realize;
   coreMethods->destroy = xmScrollBar_destroy;
   coreMethods->resize = xmScrollBar_resize;
   coreMethods->expose = xmScrollBar_expose;
   coreMethods->set_values = xmScrollBar_set_values;
   coreMethods->set_values_hook = xmScrollBar_set_values_hook;
   coreMethods->set_values_almost = xmScrollBar_set_values_almost;
   coreMethods->get_values_hook = xmScrollBar_get_values_hook;
   coreMethods->accept_focus = xmScrollBar_accept_focus;
   coreMethods->query_geometry = xmScrollBar_query_geometry;
   coreMethods->display_accelerator = xmScrollBar_display_accelerator;
}
 
void xmScrollBar_class_initialize ()
{
   _Xwms_class_initialize (xmScrollBarWidgetClass);
}

void xmScrollBar_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmScrollBarWidgetClass);
} 

void xmScrollBar_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmScrollBarWidgetClass);
}

void xmScrollBar_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmScrollBarWidgetClass);
}

void xmScrollBar_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmScrollBarWidgetClass);
}

void xmScrollBar_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmScrollBarWidgetClass);
}

void xmScrollBar_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmScrollBarWidgetClass);
}

void xmScrollBar_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmScrollBarWidgetClass);
}

Boolean xmScrollBar_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmScrollBarWidgetClass));
}

Boolean xmScrollBar_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmScrollBarWidgetClass));
}

void xmScrollBar_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmScrollBarWidgetClass);
}

void xmScrollBar_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmScrollBarWidgetClass);
}

Boolean xmScrollBar_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmScrollBarWidgetClass);
}

XtGeometryResult xmScrollBar_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmScrollBarWidgetClass));
}

void xmScrollBar_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmScrollBarWidgetClass);
}
