#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/ScrolledW.h>

#include "wms_core.h"

static void xmScrolledWindow_class_initialize ();
static void xmScrolledWindow_class_part_initialize ();
static void xmScrolledWindow_initialize ();
static void xmScrolledWindow_initialize_hook ();
static void xmScrolledWindow_realize ();
static void xmScrolledWindow_destroy ();
static void xmScrolledWindow_resize ();
static void xmScrolledWindow_expose ();
static Boolean xmScrolledWindow_set_values ();
static Boolean xmScrolledWindow_set_values_hook ();
static void xmScrolledWindow_set_values_almost ();
static void xmScrolledWindow_get_values_hook ();
static Boolean xmScrolledWindow_accept_focus ();
static XtGeometryResult xmScrolledWindow_query_geometry ();
static void xmScrolledWindow_display_accelerator ();

void _Xwms_init_xmScrolledWindow (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmScrolledWindowWidgetClass;
   coreMethods->class_initialize = xmScrolledWindow_class_initialize;
   coreMethods->class_part_initialize = 
      xmScrolledWindow_class_part_initialize;
   coreMethods->initialize = xmScrolledWindow_initialize;
   coreMethods->initialize_hook = xmScrolledWindow_initialize_hook;
   coreMethods->realize = xmScrolledWindow_realize;
   coreMethods->destroy = xmScrolledWindow_destroy;
   coreMethods->resize = xmScrolledWindow_resize;
   coreMethods->expose = xmScrolledWindow_expose;
   coreMethods->set_values = xmScrolledWindow_set_values;
   coreMethods->set_values_hook = xmScrolledWindow_set_values_hook;
   coreMethods->set_values_almost = xmScrolledWindow_set_values_almost;
   coreMethods->get_values_hook = xmScrolledWindow_get_values_hook;
   coreMethods->accept_focus = xmScrolledWindow_accept_focus;
   coreMethods->query_geometry = xmScrolledWindow_query_geometry;
   coreMethods->display_accelerator = xmScrolledWindow_display_accelerator;
}
 
void xmScrolledWindow_class_initialize ()
{
   _Xwms_class_initialize (xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmScrolledWindowWidgetClass);
} 

void xmScrolledWindow_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmScrolledWindowWidgetClass);
}

Boolean xmScrolledWindow_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmScrolledWindowWidgetClass));
}

Boolean xmScrolledWindow_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmScrolledWindowWidgetClass));
}

void xmScrolledWindow_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmScrolledWindowWidgetClass);
}

void xmScrolledWindow_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmScrolledWindowWidgetClass);
}

Boolean xmScrolledWindow_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmScrolledWindowWidgetClass);
}

XtGeometryResult xmScrolledWindow_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmScrolledWindowWidgetClass));
}

void xmScrolledWindow_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmScrolledWindowWidgetClass);
}
