#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Separator.h>

#include "wms_core.h"

static void xmSeparator_class_initialize ();
static void xmSeparator_class_part_initialize ();
static void xmSeparator_initialize ();
static void xmSeparator_initialize_hook ();
static void xmSeparator_realize ();
static void xmSeparator_destroy ();
static void xmSeparator_resize ();
static void xmSeparator_expose ();
static Boolean xmSeparator_set_values ();
static Boolean xmSeparator_set_values_hook ();
static void xmSeparator_set_values_almost ();
static void xmSeparator_get_values_hook ();
static Boolean xmSeparator_accept_focus ();
static XtGeometryResult xmSeparator_query_geometry ();
static void xmSeparator_display_accelerator ();

void _Xwms_init_xmSeparator (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmSeparatorWidgetClass;
   coreMethods->class_initialize = xmSeparator_class_initialize;
   coreMethods->class_part_initialize = 
      xmSeparator_class_part_initialize;
   coreMethods->initialize = xmSeparator_initialize;
   coreMethods->initialize_hook = xmSeparator_initialize_hook;
   coreMethods->realize = xmSeparator_realize;
   coreMethods->destroy = xmSeparator_destroy;
   coreMethods->resize = xmSeparator_resize;
   coreMethods->expose = xmSeparator_expose;
   coreMethods->set_values = xmSeparator_set_values;
   coreMethods->set_values_hook = xmSeparator_set_values_hook;
   coreMethods->set_values_almost = xmSeparator_set_values_almost;
   coreMethods->get_values_hook = xmSeparator_get_values_hook;
   coreMethods->accept_focus = xmSeparator_accept_focus;
   coreMethods->query_geometry = xmSeparator_query_geometry;
   coreMethods->display_accelerator = xmSeparator_display_accelerator;
}
 
void xmSeparator_class_initialize ()
{
   _Xwms_class_initialize (xmSeparatorWidgetClass);
}

void xmSeparator_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmSeparatorWidgetClass);
} 

void xmSeparator_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmSeparatorWidgetClass);
}

void xmSeparator_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmSeparatorWidgetClass);
}

void xmSeparator_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmSeparatorWidgetClass);
}

void xmSeparator_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmSeparatorWidgetClass);
}

void xmSeparator_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmSeparatorWidgetClass);
}

void xmSeparator_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmSeparatorWidgetClass);
}

Boolean xmSeparator_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmSeparatorWidgetClass));
}

Boolean xmSeparator_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmSeparatorWidgetClass));
}

void xmSeparator_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmSeparatorWidgetClass);
}

void xmSeparator_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmSeparatorWidgetClass);
}

Boolean xmSeparator_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmSeparatorWidgetClass);
}

XtGeometryResult xmSeparator_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmSeparatorWidgetClass));
}

void xmSeparator_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmSeparatorWidgetClass);
}
