#include <Xm/RowColumn.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>

#include "wms.h"

static int counter = 0;
static int interval = 1;

main (argc, argv)
int argc;
char *argv[];
{
   Widget toplevel, rc, inc, dec, label, interval;
   XmString xmstr;
   XtAppContext app;
   void increment ();
   void decrement ();
   void set_interval ();

   XwmsStatFile ("test2.stats");
   XwmsSelectMethod (xmLabelWidgetClass, AllMethodsMask);
   XwmsSelectMethod (xmPushButtonWidgetClass, AllMethodsMask);
   XwmsSelectMethod (xmRowColumnWidgetClass, AllMethodsMask);
   XwmsSelectMethod (applicationShellWidgetClass, AllMethodsMask);

   toplevel = XtVaAppInitialize (&app, "Test2", NULL, 0,
      &argc, argv, NULL, NULL);

   rc = XtVaCreateManagedWidget ("rc",
      xmRowColumnWidgetClass, toplevel,
      NULL);

   label = XtVaCreateManagedWidget ("0",
      xmLabelWidgetClass, rc,
      NULL);

   inc = XtVaCreateManagedWidget ("Increment",
      xmPushButtonWidgetClass, rc,
      NULL);
   XtAddCallback (inc, XmNactivateCallback, increment, label);

   dec = XtVaCreateManagedWidget ("Decrement",
      xmPushButtonWidgetClass, rc,
      NULL);
   XtAddCallback (dec, XmNactivateCallback, decrement, label);

   xmstr = XmStringCreateSimple ("Increment by 1");
   interval = XtVaCreateManagedWidget ("Interval",
      xmPushButtonWidgetClass, rc,
      XmNlabelString, xmstr,
      NULL);
   XmStringFree (xmstr);
   XtAddCallback (interval, XmNactivateCallback, set_interval, NULL);

   XtRealizeWidget (toplevel);

   XtAppMainLoop (app);
}

void increment (w, label, cbs)
   Widget w;
   Widget label;
   XmPushButtonCallbackStruct *cbs;
{
   XmString str;
   char cstr[25];

   counter += interval;
   sprintf (cstr, "%d", counter);
   str = XmStringCreateSimple (cstr);
   XtVaSetValues (label,
      XmNlabelString, str,
      NULL);
   XmStringFree (str);
}

void decrement (w, label, cbs)
   Widget w;
   Widget label;
   XmPushButtonCallbackStruct *cbs;
{
   XmString str;
   char cstr[25];

   counter -= interval;
   sprintf (cstr, "%d", counter);
   str = XmStringCreateSimple (cstr);
   XtVaSetValues (label,
      XmNlabelString, str,
      NULL);
   XmStringFree (str);
}

void set_interval (w, cd, cbs)
   Widget w;
   XtPointer cd;
   XmPushButtonCallbackStruct *cbs;
{
   XmString str;
   char cstr[25];

   interval *= 2;
   sprintf (cstr, "Increment by %d", interval);
   str = XmStringCreateSimple (cstr);
   XtVaSetValues (w,
      XmNlabelString, str,
      NULL);
   XmStringFree (str);
}
