#include <X11/Intrinsic.h>

#include "wms.h"
#include "wms_core.h"

void XwmsDeselectMethod (widget_class, method_mask)
   WidgetClass widget_class;
   long method_mask;
{
   WidgetStatisticsExtension extension;

   if (method_mask == NoMethodMask)
      return;

   /* find the extension, if it was never registered for this 
      widget class it will be installed */
   extension = _XwmsFindExtension (widget_class);

   /* If there is no mask, then there is nothing to do */
   if (method_mask == NoMethodMask)
      return;

   if (method_mask & ClassInitializeMask &&
      extension->class_initialize != NULL &&
      extension->class_initialize != _XwmsInheritMethodLater)
   { /* End statistics collection for the ClassInitialize method */
      widget_class->core_class.class_initialize = extension->class_initialize;
      extension->class_initialize = NULL;
   }

   if (method_mask & ClassPartInitializeMask &&
      extension->class_part_initialize != NULL &&
      extension->class_part_initialize != _XwmsInheritMethodLater)
   { /* End statistics collection for the ClassPartInitialize method */
      widget_class->core_class.class_part_initialize =
         extension->class_part_initialize;
      extension->class_part_initialize = NULL;
   }

   if (method_mask & InitializeMask &&
      extension->initialize != NULL &&
      extension->initialize != _XwmsInheritMethodLater)
   { /* End statistics collection for the Initialize method */
      widget_class->core_class.initialize = extension->initialize;
      extension->initialize = NULL;
   }

   if (method_mask & InitializeHookMask &&
      extension->initialize_hook != NULL &&
      extension->initialize_hook != _XwmsInheritMethodLater)
   { /* End statistics collection for the InitializeHook method */
      widget_class->core_class.initialize_hook = extension->initialize_hook;
      extension->initialize_hook = NULL;
   }

   if (method_mask & RealizeMask &&
      extension->realize != NULL &&
      extension->realize != _XwmsInheritMethodLater)
   { /* End statistics collection for the Realize method */
      widget_class->core_class.realize = extension->realize;
      extension->realize = NULL;
   }

   if (method_mask & DestroyMask &&
      extension->destroy != NULL &&
      extension->destroy != _XwmsInheritMethodLater)
   { /* End statistics collection for the Destroy method */
      widget_class->core_class.destroy = extension->destroy;
      extension->destroy = NULL;
   }

   if (method_mask & ResizeMask &&
      extension->resize != NULL &&
      extension->resize != _XwmsInheritMethodLater)
   { /* End statistics collection for the Resize method */
      widget_class->core_class.resize = extension->resize;
      extension->resize = NULL;
   }

   if (method_mask & ExposeMask &&
      extension->expose != NULL &&
      extension->expose != _XwmsInheritMethodLater)
   { /* End statistics collection for the Expose method */
      widget_class->core_class.expose = extension->expose;
      extension->expose = NULL;
   }

   if (method_mask & SetValuesMask &&
      extension->set_values != NULL &&
      extension->set_values != _XwmsInheritMethodLater)
   { /* End statistics collection for the SetValues method */
      widget_class->core_class.set_values = extension->set_values;
      extension->set_values = NULL;
   }

   if (method_mask & SetValuesHookMask &&
      extension->set_values_hook != NULL &&
      extension->set_values_hook != _XwmsInheritMethodLater)
   { /* End statistics collection for the SetValuesHook method */
      widget_class->core_class.set_values_hook = extension->set_values_hook;
      extension->set_values_hook = NULL;
   }

   if (method_mask & SetValuesAlmostMask &&
      extension->set_values_almost != NULL &&
      extension->set_values_almost != _XwmsInheritMethodLater)
   { /* End statistics collection for the SetValuesAlmost method */
      widget_class->core_class.set_values_almost = extension->set_values_almost;
      extension->set_values_almost = NULL;
   }

   if (method_mask & GetValuesHookMask &&
      extension->get_values_hook != NULL &&
      extension->get_values_hook != _XwmsInheritMethodLater)
   { /* End statistics collection for the GetValuesHook method */
      widget_class->core_class.get_values_hook = extension->get_values_hook;
      extension->get_values_hook = NULL;
   }

   if (method_mask & AcceptFocusMask &&
      extension->accept_focus != NULL &&
      extension->accept_focus != _XwmsInheritMethodLater)
   { /* End statistics collection for the AcceptFocus method */
      widget_class->core_class.accept_focus = extension->accept_focus;
      extension->accept_focus = NULL;
   }

   if (method_mask & QueryGeometryMask &&
      extension->query_geometry != NULL &&
      extension->query_geometry != _XwmsInheritMethodLater)
   { /* End statistics collection for the QueryGeometry method */
      widget_class->core_class.query_geometry = extension->query_geometry;
      extension->query_geometry = NULL;
   }

   if (method_mask & DisplayAcceleratorMask &&
      extension->display_accelerator != NULL &&
      extension->display_accelerator != _XwmsInheritMethodLater)
   { /* End statistics collection for the DisplayAcclerator method */
      widget_class->core_class.display_accelerator =
         extension->display_accelerator;
      extension->display_accelerator = NULL;
   }
}
