#include <stdio.h>

#include "wms.h"
#include "wmsstats.h"

extern FILE *wms_fp;

void _Xwms_time (timestruct)
   WMSTime *timestruct;
{
   gettimer (TIMEOFDAY, &(timestruct->timedata));
}

void _XwmsStatEntry (extension, wc, widget, method_string, begintime, endtime)
   WidgetStatisticsExtension extension;
   WidgetClass wc;
   Widget widget;
   char method_string[];
   WMSTime *begintime;
   WMSTime *endtime;
{
   static WidgetStatisticsDataRec datarec;
   struct timestruc_t *start = &(begintime->timedata);
   struct timestruc_t *end = &(endtime->timedata);

   strcpy (datarec.widget_name, XtName (widget));
   strcpy (datarec.widget_class, (XtClass (widget))->core_class.class_name);
   strcpy (datarec.method_class, wc->core_class.class_name);
   strcpy (datarec.method_string, method_string);

   if (end->tv_nsec >= start->tv_nsec)
   {
      datarec.secs = end->tv_sec - start->tv_sec;
      datarec.nanosecs = end->tv_nsec - start->tv_nsec;
   }
   else
   {
      datarec.secs = end->tv_sec - start->tv_sec - 1;
      datarec.nanosecs = end->tv_nsec - start->tv_nsec + 1000000000;
   }

#ifdef DEBUG
   printf ("rec.secs = %d recs.nanosecs = %d\n",
      datarec.secs, datarec.nanosecs);
#endif

   fwrite (&datarec, sizeof (datarec), 1, wms_fp);
}

void _XwmsClassStatEntry (extension, realwc, wc, method_string, begintime, 
      endtime)
   WidgetStatisticsExtension extension;
   WidgetClass realwc;
   WidgetClass wc;
   char method_string[];
   WMSTime *begintime;
   WMSTime *endtime;
{
   static WidgetStatisticsDataRec datarec;
   struct timestruc_t *start = &(begintime->timedata);
   struct timestruc_t *end = &(endtime->timedata);

   strcpy (datarec.widget_name, "");
   if (wc != (WidgetClass) NULL)
      strcpy (datarec.widget_class, wc->core_class.class_name);
   else
      strcpy (datarec.widget_class, "");
   strcpy (datarec.method_class, realwc->core_class.class_name);
   strcpy (datarec.method_string, method_string);

   if (end->tv_nsec >= start->tv_nsec)
   {
      datarec.secs = end->tv_sec - start->tv_sec;
      datarec.nanosecs = end->tv_nsec - start->tv_nsec;
   }
   else
   {
      datarec.secs = end->tv_sec - start->tv_sec - 1;
      datarec.nanosecs = end->tv_nsec - start->tv_nsec + 1000000000;
   }

   fwrite (&datarec, sizeof (datarec), 1, wms_fp);
}
